# -*- coding: euc-jp -*-
module Thermo_Advanced_Function
# å롼, ؿ use ʣǮϳشؿ׻⥸塼
  require "thermo_const.rb"
  include Thermo_Const
  require "phys_const.rb"
  include Phys_Const
  require "thermo_function.rb"
  include Thermo_Function
  require "algebra.rb"
  include Algebra
  require "statistics.rb"
  include Statistics

#--------------------------------------------------------

def self.precip_water( p, qv, error=999.0 )  # Ĺ߿̤׻. ñ̤ [kg/m^2]
# ʬϰϤ p ǿξ岼üǼưŪ˻.
# ݤ狼ȼ, ٺɸʬΤǤϤʤ,
# ϳʿդ鵤ɸ֤ľʬ.
#  use Algebra
#  use Phys_Const
#  implicit none
#  real, intent(in) :: p[:)  #  [Pa]
#  real, intent(in) :: qv[size(p))  #  [kg/kg]
#  real, intent(in], optional :: error  # error
#  integer, intent(in], optional :: dl  # ǥХå٥
#  integer :: nx, i
#  real, dimension(size(p)) :: tmp_p, tmp_qv
#  real :: precip

  nx=p.length

  tmp_qv=NArray.sfloat(nx)
  tmp_p=NArray.sfloat(nx)
  pw=0.0

#-- ʬΤ, ؤ
  for i in 0..nx-1
     tmp_qv[i]=qv[nx-i-1]
     tmp_p[i]=p[nx-i-1]
  end

  pw=Algebra.rectangle_int( tmp_p, tmp_qv, tmp_p[0], tmp_p[nx-1], error )

  precip_water=pw/G

  return precip_water

end

#-----------------------------------------------------
#-----------------------------------------------------

def self.t_LNB( z_ref, z, t, p, qv, opt=1, error=999.0 )  # LNB ٤Ǥβ٤׻.
# LFC ٰʾǺƤӴĶ˰̤ȸ٤ LNB Ǥ.
# , ºݤ¬ǡǤ, ¬ưˤ, LFC ľ LNB 
# ã礬.
# , opt Ȥ, LFC Ƥ LNB ׻ˡ
# 鲼˲ƺǽ˸򺹤٤ LNB ˡ
# 2 ѥѰդ뤳Ȥˤ.
# opt = 1, LFC . opt = 2 ľ夫׻.
# ǥեȤǤ opt = 1 ׻.
#  use Statistics
#  use Thermo_Function
#  implicit none
#  real, intent(in) :: z_ref  #  [m]
#  real, intent(in) :: z[:)  # ٺɸ [m]
#  real, intent(in) :: temp(size(z))  #  [K]
#  real, intent(in) :: pres(size(z))  #  [Pa]
#  real, intent(in) :: qv[size(z))  #  [kg/kg]
#  integer, intent(in], optional :: opt  # ׻ˡΥץ
#  real, intent(in], optional :: errorf
#  integer, intent(in], optional :: dl  # ǥХå٥
#  integer :: i, nz, iz, iept, counter
#  real :: sept(size(z))
#  real :: eptiz, eptiz1, ept_ref, z_sol
#  real :: error

  nz=z.length
  iept=0

#-- ľ˰̤׻.
  for i in 0..nz-1
     sept[i]=Thermo_Function.thetaes_Bolton( t[i], p[i] )
  end

#-- z_ref Ǥ̤׻.
  iz=Statistics.interpo_search_1d( z, z_ref, nz+1 )

#-- iz  iz+1 Ǥ̤׻.
  if iz!=nz+1 then
     if t[iz]!=error and qv[iz]!=error and p[iz]!=error \
        and t[iz+1]!=error and qv[iz+1]!=error and p[iz+1]!=error then
        eptiz=Thermo_Function.thetae_Bolton( t[iz], qv[iz], p[iz] )
        eptiz1=Thermo_Function.thetae_Bolton( t[iz+1], qv[iz+1], p[iz+1] )
#-- δ֤̤
        ept_ref=Statistics.interpolation_1d( z[iz], z[iz+1], eptiz, eptiz1, z_ref )

        counter=0

        if opt==2 then
#           for i in nz-1..iz  # 夫鲼˲.
#              if (sept[i]-ept_ref)*(sept[i-1]-ept_ref)<0.0 then
#                 iept=i-1  # 夫鲼˲ƤΤ, 1 ǲΥǡ iept.
#                 break
#              end
#           end
           (nz-1).downto(iz) do |i|  # 夫鲼˲.
              if (sept[i]-ept_ref)*(sept[i-1]-ept_ref)<0.0 then
                 iept=i-1  # 夫鲼˲ƤΤ, 1 ǲΥǡ iept.
                 break
              end
           end
        else
#-- z_ref ι٤ ept_ref ˰̤δط׻.
           for i in iz..nz-2
              if (sept[i]-ept_ref)*(sept[i+1]-ept_ref)<0.0 then
                 counter=counter+1
                 if counter==2 then
                    iept=i
                    break
                 end
              end
           end
        end
#-- ѡ̤Ķ˰̤ȵžľι٤ iept Ǥ.
#-- , iept  iept+1 ˰̤٤ޤ.
        if iept>0 and iept<nz then
           t_LNB=Statistics.interpolation_1d( sept[iept], sept[iept+1], t[iept], t[iept+1], ept_ref )
        else
           t_LNB=error
        end

     else

        t_LNB=error

     end

  else

     t_LNB=error

  end

  return t_LNB

end

#-----------------------------------------------------
#-----------------------------------------------------

def self.t_LFC( z_ref, z, t, p, qv, error=999.0 )  # LFC ٤Ǥβ٤׻.
# ٤Ǥ̤徺Ȥ, Ϥ˰̤Ȱפ٤
# LFC Ǥ. 
# Ǥ, Ϥ˰̤ȸ򺹤 2 , 
# ޤ뤳Ȥǹ٤ꤹ.
#  use Statistics
#  use Thermo_Function
#  implicit none
#  real, intent(in) :: z_ref  #  [m]
#  real, intent(in) :: z[:)  # ٺɸ [m]
#  real, intent(in) :: temp(size(z))  #  [K]
#  real, intent(in) :: pres(size(z))  #  [Pa]
#  real, intent(in) :: qv[size(z))  #  [kg/kg]
#  real, intent(in], optional :: errorf
#  integer, intent(in], optional :: dl  # ǥХå٥
#  integer :: i, nz, iz, iept
#  real :: sept(size(z))
#  real :: eptiz, eptiz1, ept_ref, z_sol
#  real :: error

  nz=z.length
  iept=0

  sept=NArray.sfloat(nz)

#-- ľ˰̤׻.
  for i in 0..nz-1
     sept[i]=Thermo_Function.thetaes_Bolton( t[i], p[i] )
  end

#-- z_ref Ǥ̤׻.
  iz=Statistics.interpo_search_1d( z, z_ref, nz+1 )

#-- iz  iz+1 Ǥ̤׻.
  if iz!=nz+1 then
     if t[iz]!=error and qv[iz]!=error and p[iz]!=error \
        and t[iz+1]!=error and qv[iz+1]!=error and p[iz+1]!=error then

        eptiz=Thermo_Function.thetae_Bolton( t[iz], qv[iz], p[iz] )
        eptiz1=Thermo_Function.thetae_Bolton( t[iz+1], qv[iz+1], p[iz+1] )

#-- δ֤̤
        ept_ref=Statistics.interpolation_1d( z[iz], z[iz+1], eptiz, eptiz1, z_ref )
#-- z_ref ι٤ ept_ref ˰̤δط׻.
        for i in iz..nz-2
           if (sept[i]-ept_ref)*(sept[i+1]-ept_ref)<0.0 then
              iept=i
              break
           end
        end
#-- ѡ̤Ķ˰̤ȵžľι٤ iept Ǥ.
#-- , iept  iept+1 ˰̤٤ޤ.
        if iept>0 and iept<nz then
           t_LFC=Statistics.interpolation_1d( sept[iept], sept[iept+1], t[iept], t[iept+1], ept_ref )
        else
           t_LFC=error
        end

     else

        t_LFC=error

     end

  else

     t_LFC=error

  end

  return t_LFC

end

#-----------------------------------------------------
#-----------------------------------------------------

def self.z_LCL( z_ref, z, t, p, qv, error=999.0 )  # LCL ٤׻.
# ѡ뤬 z_ref ǮǾ徺, β٤ãȤι٤
# LCL ٤ȤʤΤ, z_ref 鴥ǮΨǰʲΤ褦˷׻.
# LCL ٤ z_LCL Ȥ, ѡδ٤ z_ref Ȥ,
# LCL ãޤǤϴǮΨ \Gamma _d ѲΤ,
# $\Gamma _d=\frac{g}{C_p} =-\frac{T_LCL-T_ref}{z_LCL-z_ref} $
# ȤΩ. , z_LCL ˤĤƲ򤯤,
# $z_LCL=z_ref+\frac{C_p}{g} (T_ref-T_LCL)$
# Ȥʤ.
#  use Thermo_Const
#  use Thermo_Function
#  use Phys_Const
#  use Statistics
#  implicit none
#  real, intent(in) :: z_ref  #  [m]
#  real, intent(in) :: z[:)  # ٺɸ [m]
#  real, intent(in) :: temp(size(z))  #  [K]
#  real, intent(in) :: pres(size(z))  #  [Pa]
#  real, intent(in) :: qv[size(z))  #  [kg/kg]
#  real ,intent(in], optional :: errorf
#  integer, intent(in], optional :: dl  # ǥХå٥
#  integer :: iz_ref
#  real :: TLCL
#  real :: T_ref, P_ref, qv_ref
#  real :: error

  nx=z.length

  iz_ref=Statistics.interpo_search_1d( z, z_ref, nx+1 )

  if iz_ref!=nx+1 then
     if t[iz_ref]!=error and qv[iz_ref]!=error and p[iz_ref]!=error \
        and t[iz_ref+1]!=error and qv[iz_ref+1]!=error and p[iz_ref+1]!=error then
        t_ref=Statistics.interpolation_1d( z[iz_ref], z[iz_ref+1], t[iz_ref], t[iz_ref+1], z_ref )
        p_ref=Statistics.interpolation_1d( z[iz_ref], z[iz_ref+1], p[iz_ref], p[iz_ref+1], z_ref )
        qv_ref=Statistics.interpolation_1d( z[iz_ref], z[iz_ref+1], qv[iz_ref], qv[iz_ref+1], z_ref )

        tlcl=Thermo_Function.tqvP_2_TLCL( t_ref, qv_ref, p_ref )  # z_ref Υѡ LCL Ǥβ.
        z_LCL=z_ref+(Cpd/G)*(t_ref-tlcl)

     else

        z_LCL=error

     end

  else

     z_LCL=error

  end

  return z_LCL

end

#-----------------------------------------------------
#-----------------------------------------------------

def self.z_LFC( z_ref, z, t, p, qv, error=999.0 )  # LFC ٤׻.
# ٤Ǥ̤徺Ȥ, Ϥ˰̤Ȱפ٤
# LFC Ǥ. 
# Ǥ, Ϥ˰̤ȸ򺹤 2 , 
# ޤ뤳Ȥǹ٤ꤹ.
#  use Statistics
#  use Thermo_Function
#  implicit none
#  real, intent(in) :: z_ref  #  [m]
#  real, intent(in) :: z[:)  # ٺɸ [m]
#  real, intent(in) :: temp(size(z))  #  [K]
#  real, intent(in) :: pres(size(z))  #  [Pa]
#  real, intent(in) :: qv[size(z))  #  [kg/kg]
#  real, intent(in], optional :: errorf
#  integer, intent(in], optional :: dl  # ǥХå٥
#  integer :: i, nz, iz, iept
#  real :: sept(size(z))
#  real :: eptiz, eptiz1, ept_ref, z_sol
#  real :: error

  nz=z.length
  iept=0
  sept=NArray.sfloat(nz)

#-- ľ˰̤׻.
  for i in 0..nz-1
     sept[i]=Thermo_Function.thetaes_Bolton( t[i], p[i] )
  end

#-- z_ref Ǥ̤׻.
  iz=Statistics.interpo_search_1d( z, z_ref, nz+1 )

  if iz!=nz+1 then
     if t[iz]!=error and qv[iz]!=error and p[iz]!=error \
        and t[iz+1]!=error and qv[iz+1]!=error and p[iz+1]!=error then
#-- iz  iz+1 Ǥ̤׻.
        eptiz=Thermo_Function.thetae_Bolton( t[iz], qv[iz], p[iz] )
        eptiz1=Thermo_Function.thetae_Bolton( t[iz+1], qv[iz+1], p[iz+1] )
#-- δ֤̤
        ept_ref=Statistics.interpolation_1d( z[iz], z[iz+1], eptiz, eptiz1, z_ref )
#-- z_ref ι٤ ept_ref ˰̤δط׻.
        for i in iz..nz-2
           if (sept[i]-ept_ref)*(sept[i+1]-ept_ref)<0.0 then
              iept=i
              break 
           end
        end
#-- ѡ̤Ķ˰̤ȵžľι٤ iept Ǥ.
#-- , iept  iept+1 ˰̤٤ޤ.
        if iept>0 and iept<=nz then
           z_LFC=Statistics.interpolation_1d( sept[iept], sept[iept+1], z[iept], z[iept+1], ept_ref )
        else
           z_LFC=error
        end

     else

        z_LFC=error

     end

  else

     z_LFC=error

  end

  return z_LFC

end

#-----------------------------------------------------
#-----------------------------------------------------

def self.z_LNB( z_ref, z, t, p, qv, opt=1, error=999.0 )  # LNB ٤׻.
# LFC ٰʾǺƤӴĶ˰̤ȸ٤ LNB Ǥ.
# , ºݤ¬ǡǤ, ¬ưˤ, LFC ľ LNB 
# ã礬.
# , opt Ȥ, LFC Ƥ LNB ׻ˡ
# 鲼˲ƺǽ˸򺹤٤ LNB ˡ
# 2 ѥѰդ뤳Ȥˤ.
# opt = 1, LFC . opt = 2 ľ夫׻.
# ǥեȤǤ opt = 1 ׻.
#  use Statistics
#  use Thermo_Function
#  implicit none
#  real, intent(in) :: z_ref  #  [m]
#  real, intent(in) :: z[:)  # ٺɸ [m]
#  real, intent(in) :: temp(size(z))  #  [K]
#  real, intent(in) :: pres(size(z))  #  [Pa]
#  real, intent(in) :: qv[size(z))  #  [kg/kg]
#  integer, intent(in], optional :: opt  # ׻ˡΥץ
#  real, intent(in], optional :: errorf
#  integer, intent(in], optional :: dl  # ǥХå٥
#  integer :: i, nz, iz, iept, counter
#  real :: sept(size(z))
#  real :: eptiz, eptiz1, ept_ref, z_sol
#  real :: error

  nz=z.length
  iept=0
  sept=NArray.sfloat(nz)

#-- ľ˰̤׻.
  for i in 0..nz-1
     sept[i]=Thermo_Function.thetaes_Bolton( t[i], p[i] )
  end

#-- z_ref Ǥ̤׻.
  iz=Statistics.interpo_search_1d( z, z_ref, nz+1 )

  if iz!=nz+1 then
     if t[iz]!=error and qv[iz]!=error and p[iz]!=error \
        and t[iz+1]!=error and qv[iz+1]!=error and p[iz+1]!=error then
#-- iz  iz+1 Ǥ̤׻.
        eptiz=Thermo_Function.thetae_Bolton( t[iz], qv[iz], p[iz] )
        eptiz1=Thermo_Function.thetae_Bolton( t[iz+1], qv[iz+1], p[iz+1] )
#-- δ֤̤
        ept_ref=Statistics.interpolation_1d( z[iz], z[iz+1], eptiz, eptiz1, z_ref )

        counter=0

        if opt==2 then
           (nz-1).downto(iz) do |i|  # 夫鲼˲.
              if (sept[i]-ept_ref)*(sept[i-1]-ept_ref)<0.0 then
                 iept=i-1  # 夫鲼˲ƤΤ, 1 ǲΥǡ iept.
                 break
              end
           end
#           for i in nz-1..iz  # 夫鲼˲.
#              if (sept[i]-ept_ref)*(sept[i-1]-ept_ref)<0.0 then
#                 iept=i-1  # 夫鲼˲ƤΤ, 1 ǲΥǡ iept.
#                 break
#              end
#           end
        else
#-- z_ref ι٤ ept_ref ˰̤δط׻.
           for i in iz..nz-2
              if (sept[i]-ept_ref)*(sept[i+1]-ept_ref)<0.0 then
                 counter=counter+1
                 if counter==2 then
                    iept=i
                    break
                 end
              end
           end
        end

#-- ѡ̤Ķ˰̤ȵžľι٤ iept Ǥ.
#-- , iept  iept+1 ˰̤٤ޤ.
        if iept>0 and iept<nz then
           z_LNB=Statistics.interpolation_1d( sept[iept], sept[iept+1], z[iept], z[iept+1], ept_ref )
        else
           z_LNB=error
        end

     else

        z_LNB=error

     end

  else

     z_LNB=error

  end

  return z_LNB

end

#-----------------------------------------------------
#-----------------------------------------------------

def self.cape( p, z, qv, t, z_ref, opt=1, error=999.0 )
# ή֥ͭͥ륮 (Convective Available Potential Energy) ׻.
#  use Thermo_Const
#  use Thermo_Function
#  use Algebra
#  use Statistics
#  implicit none
#  real, intent(in) :: tmp_p(:)  #  [Pa]
#  real, intent(in) :: tmp_z(size(tmp_p))  #  [m]
#  real, intent(in) :: tmp_qv(size(tmp_p))  #  [kg/kg]
#  real, intent(in) :: tmp_t(size(tmp_p))  #  [K]
#  real, intent(in) :: z_ref  # ѡ夲 [m]
#  real, intent(in], optional :: errorf
#  integer, intent(in], optional :: opt  # LNB ׻κݤΥץ (z_LNB )
#  integer, intent(in], optional :: dl  # ǥХå٥
#  integer :: nx, i, iz_LFC, iz_LNB, option
#  real :: PLFC, TLFC, PLNB, ZLFC, ZLNB
#  real :: tmp(size(tmp_p)], t_par(size(tmp_p))
#  real :: inv_tmp(size(tmp_p)], inv_p(size(tmp_p))
#  real :: error

  nx=p.length
  tmp=NArray.sfloat(nx)
  t_par=NArray.sfloat(nx)
  inv_tmp=NArray.sfloat(nx)
  inv_p=NArray.sfloat(nx)
  tmp[0..nx-1]=0.0
  t_par[0..nx-1]=0.0
  inv_tmp[0..nx-1]=0.0
  inv_p[0..nx-1]=0.0

#-- LFC, LNB Ǥι, , Ϥη׻

  tlfc=t_LFC( z_ref, z, t, p, qv )
  zlfc=z_LFC( z_ref, z, t, p, qv, error )
  zlnb=z_LNB( z_ref, z, t, p, qv, opt, error )

  if zlfc!=error and zlnb!=error then

     iz_LFC=Statistics.interpo_search_1d( z, zlfc, nx+1 )
     iz_LNB=Statistics.interpo_search_1d( z, zlnb, nx+1 )

  else

     iz_LFC=nx+1
     iz_LNB=nx+1

  end

  if iz_LFC!=nx+1 and iz_LNB!=nx+1 and iz_LFC!=0 and iz_LNB!=0 then

     if t[iz_LFC]!=error and qv[iz_LFC]!=error and p[iz_LFC]!=error \
        and t[iz_LFC+1]!=error and qv[iz_LFC+1]!=error and p[iz_LFC+1]!=error \
        and t[iz_LNB]!=error and qv[iz_LNB]!=error and p[iz_LNB]!=error \
        and t[iz_LNB+1]!=error and qv[iz_LNB+1]!=error and p[iz_LNB+1]!=error then

        plfc=Statistics.interpolation_1d( z[iz_LFC], z[iz_LFC+1], p[iz_LFC], p[iz_LFC+1], zlfc )
        plnb=Statistics.interpolation_1d( z[iz_LNB], z[iz_LNB+1], p[iz_LNB], p[iz_LNB+1], zlnb )

        for i in 0..nx-1
           if iz_LFC<=i and i<=iz_LNB+1 then

              if error==t[i] then
                 tmp[i]=error
              else
                 t_par[i]=Thermo_Function.moist_laps_temp( plfc, tlfc, p[i] )
                 tmp[i]=(t_par[i]-t[i])/p[i]
              end
           else
              tmp[i]=error
           end
        end

#-- ʬΤ, ؤ
        for i in 0..nx-1
           inv_tmp[i]=tmp[nx-i-1]
           inv_p[i]=p[nx-i-1]
        end

        cape=Algebra.rectangle_int( inv_p, inv_tmp, plnb, plfc, error )
        cape=cape*Rd

     else

        cape=error

     end

  else

     cape=error

  end

  return cape

end

#-----------------------------------------------------
#-----------------------------------------------------

def self.cin( p, z, qv, t, z_ref, error=999.0 )
# ήͥ륮 (Convective INhibitation energy) ׻.
#  use Thermo_Const
#  use Algebra
#  use Thermo_Function
#  use Statistics
#  implicit none
#  real, intent(in) :: tmp_p(:)  #  [Pa]
#  real, intent(in) :: tmp_z(size(tmp_p))  #  [m]
#  real, intent(in) :: tmp_qv(size(tmp_p))  #  [kg/kg]
#  real, intent(in) :: tmp_t(size(tmp_p))  #  [K]
#  real, intent(in) :: z_ref  # ѡ夲 [m]
#  real, intent(in], optional :: errorf
#  integer, intent(in], optional :: dl  # ǥХå٥
#  integer :: nx, i, iz_LFC, iz_ref, iz_LCL
#  real :: PLFC, TLFC, ZLFC, PLCL, ZLCL, TLCL, p_ref, T_ref, qv_ref
#  real :: tmp(size(tmp_p)], t_par(size(tmp_p))
#  real :: inv_tmp(size(tmp_p)], inv_p(size(tmp_p))
#  real :: error

  nx=p.length

  t_par=NArray.sfloat(nx)
  tmp=NArray.sfloat(nx)
  inv_tmp=NArray.sfloat(nx)
  inv_p=NArray.sfloat(nx)
  t_par[0..nx-1]=0.0
  tmp[0..nx-1]=0.0
  inv_tmp[0..nx-1]=0.0
  inv_p[0..nx-1]=0.0

#-- z_ref Ȥ, LCL, LFC Ǥβ, , Ϥη׻

#-- LFC ٤ѿ׻
  tlfc=t_LFC( z_ref, z, t, p, qv )
  zlfc=z_LFC( z_ref, z, t, p, qv )

  iz_LFC=Statistics.interpo_search_1d( z, zlfc, nx+1 )
  iz_ref=Statistics.interpo_search_1d( z, z_ref, nx+1 )

  if iz_LFC!=nx+1 and iz_ref!=nx+1 then
     if t[iz_LFC]!=error and qv[iz_LFC]!=error and p[iz_LFC]!=error \
        and t[iz_LFC+1]!=error and qv[iz_LFC+1]!=error and p[iz_LFC+1]!=error \
        and t[iz_ref]!=error and qv[iz_ref]!=error and p[iz_ref]!=error \
        and t[iz_ref+1]!=error and qv[iz_ref+1]!=error and p[iz_ref+1]!=error then

        plfc=Statistics.interpolation_1d( z[iz_LFC], z[iz_LFC+1], p[iz_LFC], p[iz_LFC+1], zlfc )
        p_ref=Statistics.interpolation_1d( z[iz_ref], z[iz_ref+1], p[iz_ref], p[iz_ref+1], z_ref )
        t_ref=Statistics.interpolation_1d( z[iz_ref], z[iz_ref+1], t[iz_ref], t[iz_ref+1], z_ref )
        qv_ref=Statistics.interpolation_1d( z[iz_ref], z[iz_ref+1], qv[iz_ref], qv[iz_ref+1], z_ref )

#-- LCL ٤ѿ׻
        tlcl=Thermo_Function.tqvP_2_TLCL( t_ref, qv_ref, p_ref )
        zlcl=z_LCL( z_ref, z, t, p, qv )
        iz_LCL=Statistics.interpo_search_1d( z, zlcl, nx+1 )

        if iz_LCL!=nx+1 then
        if t[iz_LCL]!=error and qv[iz_LCL]!=error and p[iz_LCL]!=error \
           and t[iz_LCL+1]!=error and qv[iz_LCL+1]!=error and p[iz_LCL+1]!=error then

           plcl=Statistics.interpolation_1d( z[iz_LCL], z[iz_LCL+1], p[iz_LCL], p[iz_LCL+1], zlcl )

# Ϥβ٤ T ƤΤ, ޤ LCL ׻, ι
# ޤǤǮ, ʹߤ򼾽Ǯǥѡ벹٤׻.

           for i in 0..nx-1
              if i>=iz_ref and i<=iz_LCL+1 then
                 t_par[i]=t_ref-(G/Cpd)*(z[i]-z_ref)
              else
                 if i>iz_LCL+1 and i<=iz_LFC+1 then
                    t_par[i]=Thermo_Function.moist_laps_temp( plcl, tlcl, p[i] )
                 else
                    t_par[i]=error
                 end
              end

              if error==t[i] or t_par[i]==error then
                 tmp[i]=error
              else
                 tmp[i]=(t_par[i]-t[i])/p[i]
              end
           end

#-- ʬΤ, ؤ
           for i in 0..nx-1
              inv_tmp[i]=tmp[nx-i-1]
              inv_p[i]=p[nx-i-1]
           end

           cin=Algebra.rectangle_int( inv_p, inv_tmp, plfc, p_ref, error )
           cin=cin*Rd

        else

           cin=error

        end

        else

           cin=error

        end

     else

        cin=error

     end

  else

     cin=error

  end

  return cin

end

#-----------------------------------------------------
#-----------------------------------------------------

#-----------------------------------------------------
#-----------------------------------------------------

#real function




#  return
#end function

#-----------------------------------------------------
#-----------------------------------------------------





end
